VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "Form1"
   ClientHeight    =   3195
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   4905
   LinkTopic       =   "Form1"
   ScaleHeight     =   3195
   ScaleWidth      =   4905
   StartUpPosition =   3  'Windows Default
   Begin VB.TextBox txtResult 
      Height          =   2295
      Left            =   120
      Locked          =   -1  'True
      MultiLine       =   -1  'True
      ScrollBars      =   2  'Vertical
      TabIndex        =   5
      Top             =   840
      Width           =   2655
   End
   Begin VB.TextBox txtN 
      Height          =   285
      Left            =   360
      TabIndex        =   4
      Text            =   "5"
      Top             =   480
      Width           =   615
   End
   Begin VB.TextBox txtM 
      Height          =   285
      Left            =   360
      TabIndex        =   2
      Text            =   "5"
      Top             =   120
      Width           =   615
   End
   Begin VB.CommandButton Command1 
      Caption         =   "List"
      Default         =   -1  'True
      Height          =   375
      Left            =   1200
      TabIndex        =   0
      Top             =   240
      Width           =   615
   End
   Begin VB.Label Label1 
      Caption         =   "M!/N!/(M-N)!"
      Height          =   255
      Index           =   3
      Left            =   2040
      TabIndex        =   9
      Top             =   480
      Width           =   975
   End
   Begin VB.Label lblCalculatedNumber 
      BorderStyle     =   1  'Fixed Single
      Height          =   255
      Left            =   3120
      TabIndex        =   8
      Top             =   480
      Width           =   855
   End
   Begin VB.Label lblSolutions 
      BorderStyle     =   1  'Fixed Single
      Height          =   255
      Left            =   3120
      TabIndex        =   7
      Top             =   120
      Width           =   855
   End
   Begin VB.Label Label1 
      Caption         =   "Solutions:"
      Height          =   255
      Index           =   2
      Left            =   2040
      TabIndex        =   6
      Top             =   120
      Width           =   735
   End
   Begin VB.Label Label1 
      Caption         =   "N"
      Height          =   255
      Index           =   1
      Left            =   120
      TabIndex        =   3
      Top             =   480
      Width           =   255
   End
   Begin VB.Label Label1 
      Caption         =   "M"
      Height          =   255
      Index           =   0
      Left            =   120
      TabIndex        =   1
      Top             =   120
      Width           =   255
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private Function Factorial(ByVal N As Integer) As Long
Dim i As Integer
Dim total As Long

    total = 1
    For i = 2 To N
        total = total * i
    Next i
    Factorial = total
End Function

' Pick N items from a list between first_allowed
' and last_allowed. Return the solutions in the
' collection as space-separated characters.
'
' For example, MchoseN(3, 2, 5, solutions) means
' pick 3 items from the values 2, 3, 4, 5 and
' returns 2 3 4, 2 3 5, and 3 4 5.
Private Sub MchoseN(ByVal N As Integer, ByVal first_allowed As Integer, ByVal last_allowed As Integer, ByVal solutions As Collection)
Dim i As Integer
Dim txt As String
Dim partial_solutions As Collection

    ' If N < 1, we don't need to pick any more
    ' items.
    ' If N > last_allowed - first_allowed + 1,
    ' there are too few items for a solution.
    ' If N = last_allowed - first_allowed + 1,
    ' all the items must be in the solution.

    If N < 1 Then
        ' We don't need to pick any more.
        ' Do nothing.
    ElseIf N > last_allowed - first_allowed + 1 Then
        ' There are not enough items.
        ' Do nothing.
    ElseIf N = last_allowed - first_allowed + 1 Then
        ' All the items must be in the solution.
        txt = Format$(first_allowed)
        For i = first_allowed + 1 To last_allowed
            txt = txt & " " & Format$(i)
        Next i
        solutions.Add txt
    Else
        ' Get solutions containing first_allowed.
        Set partial_solutions = New Collection
        If N = 1 Then
            partial_solutions.Add ""
        Else
            MchoseN N - 1, first_allowed + 1, last_allowed, partial_solutions
        End If

        ' Add first_allowed to make the full
        ' solutions.
        For i = 1 To partial_solutions.Count
            solutions.Add Format$(first_allowed) & _
                " " & partial_solutions(i)
        Next i

        ' Get solutions not containing first_allowed.
        Set partial_solutions = New Collection
        MchoseN N, first_allowed + 1, last_allowed, partial_solutions

        ' Add these to the solutions.
        For i = 1 To partial_solutions.Count
            solutions.Add partial_solutions(i)
        Next i
    End If
End Sub
Private Sub Command1_Click()
Dim M As Integer
Dim N As Integer
Dim solutions As Collection
Dim i As Integer
Dim txt As String

    ' Get the solutions.
    Set solutions = New Collection
    M = CInt(txtM.Text)
    N = CInt(txtN.Text)
    MchoseN N, 1, M, solutions

    ' Display the solutions.
    For i = 1 To solutions.Count
        txt = txt & solutions(i) & vbCrLf
    Next i

    txtResult.Text = txt
    lblSolutions.Caption = Format$(solutions.Count)

    ' Calculate the number of combinations directly.
    lblCalculatedNumber.Caption = _
        Factorial(M) / _
        Factorial(N) / _
        Factorial(M - N)
End Sub
Private Sub Form_Resize()
Dim hgt As Single

    hgt = ScaleHeight - txtResult.Top
    If hgt < 120 Then hgt = 120
    txtResult.Move 0, txtResult.Top, ScaleWidth, hgt
End Sub


